
//package hypertree.demo;

//import hypertree.HyperTree;
//import hypertree.HTView;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.applet.*;
import java.awt.*;
import java.net.URL;
import java.awt.event.*;

/**
 * The Demo class implements a demo for HyperTree. It display an HyperTree
 * view of a demo tree.
 * The demo tree is build from a file tree, passed in parameter.
 * Demo could take an argument, the path from which
 * start the representing of files.
 * If no arguments is given, the treemap start from the root.
 *
 * @author     silvio
 * @created    15 de Setembro de 2008
 */
public class HTApplet extends Applet {
	// Appelet

	private static HTFileNode root = null;
	// the root of the demo tree
	private static HyperTree hypertree = null;
	// the hypertree builded
	private static HTView view;
	TextField searchField;
	
	private Image imageH;
	private Image imageB;
	private Image imageS;
	// Bruno
	/**
	 *  Description of the Field
	 */
	public HTLoadSVG dlgFormas;
	private HTVector graph = null;
	boolean lineGraph = true;


	/**
	 *Constructor for the HTApplet object
	 */
	public HTApplet() { }


	/**
	 *  Description of the Method
	 *
	 * @return    The graph value
	 */

	HTVector getGraph() {
		return graph;
	}


	/**
	 *  Description of the Method
	 */
	public void init() {

		String pathRoot = null;
		//
		String htFile = getParameter("htfile");
		//
		String htHintColor = getParameter("hthintcolor");
		//
		String htCenterNode = getParameter("htcenternode");
		//
		String htBackColor = getParameter("htbackcolor");
		//
		String htLinkColor = getParameter("htlinkcolor");
		String htGraphColor = getParameter("htgraphcolor");
		//
		String htSearchColor = getParameter("htsearchcolor");
		String htBorderType = getParameter("htbordertype");
		//
		String htFont = getParameter("htfont");
		//
		String htFontSize = getParameter("htfontsize");
		//
		String htHomeImage = getParameter("hthomeimage");
		//
		String htHelpImage = getParameter("hthelpimage");
		//
		String htBackImage = getParameter("htbackimage");
		//
		String htHelpFile = getParameter("hthelpfile");
		//
		String htUrlAdr = getParameter("hturladr");
		//
		String htOpenWindow = getParameter("htopenwindow");
		String htLeafNode = getParameter("htleafnode");
		//
		String htParentNode = getParameter("htparentnode");
		//
		String htHasFolder = getParameter("hthasfolder");
		//
		String htSearchType = getParameter("htsearchtype");
		// 14/11/2005
		// Nome do arquivo com os poligonos
		String htFileShape = getParameter("htfileshape");
		//

		/*
		 *  <PARAM  name="htlabelcount" value="Nmero de Subprojetos:">
		 *  <PARAM  name="htsumtags" value="ORAMENTO:;PESQUISADORES:">
		 */
		String htLabelCount = getParameter("htlabelcount");
		String htSumTags = getParameter("htsumtags");
		// 25/04/2008

		System.out.println("INIT");

		if (htFile == null) {
			System.out.println("Arquivo com a rvore Hiperblica no foi especificado");
			return;
		}

//	try {
//	      if( Class.forName("netscape.security.PrivilegeManager") != null )
//    			netscape.security.PrivilegeManager.enablePrivilege("UniversalAwtEventQueueAccess");//
//	} catch (Exception e) {
//    		// privilege is not currently granted
//	}

		try {

			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), htFile)).openStream());
			ObjectInputStream pi = new ObjectInputStream(zip);
			root = (HTFileNode) pi.readObject();
			convertPixes2Image(root, true);
			zip.close();

		} catch (Exception e) {
			System.out.println("Leitura de Objetos  :  " + e.toString());
			return;
		}

		if (root == null) {
			System.err.println("Erro : No foi possvel iniciar a rvore Hiperblica");
			return;
		}

		try {
			GZIPInputStream zip = new GZIPInputStream((new URL(getCodeBase(), htFile.toLowerCase().replaceAll(".htz", ".vec")).openStream()));
			ObjectInputStream pi = new ObjectInputStream(zip);
			HTVector graphOld = (HTVector) pi.readObject();
			graph = new HTVector();

			for (int i = 0; i < graphOld.size(); i++) {
				
				HTPointGraph htp = (HTPointGraph) graphOld.elementAt(i);
				
				//System.out.println(i + " " + htp.getNode1().getID());
				HTFileNode no1 = findNo(root, htp.getNode1().getID());
				HTFileNode no2 = findNo(root, htp.getNode2().getID());
				HTPointGraph v = new HTPointGraph(no1, no2);
                        v.setDirecionado(htp.getDirecionado());
				v.setArcName(htp.getArcName());
				graph.add((Object) v);
			}
			zip.close();

		} catch (Exception e) {
			graph = new HTVector();
			System.out.println(e.toString());
		}

		//loadGraph(htFile);

		loadHint(htFile);

		System.out.println("INIT 1");

		try {
			hypertree = new HyperTree(root, this);

			view = hypertree.getView();

			loadGraph(htFile);
			
			view.setLineGraph(graph, lineGraph);
			
			
		} catch (Exception e) {
			System.out.println("INIT 1" + " " + e.toString());
		}

		System.out.println("INIT 2");

		if (htLabelCount != null) {
			view.setLabelCount(htLabelCount);
		}
		if (htSumTags != null) {
			view.setSumTags(htSumTags);
			// Inicializa as formas
			// Pega o nome do arquivo que esta no HTML
		}
		if (htFileShape != null) {
			view.setFileShape(htFileShape);
		} else {
			view.setFileShape("dataflow.svg");
			// Se nao tiver nenhum nome, usa o padrao
		}
		try {
			// Pega o caminho do Applet
			URL url = new URL(getCodeBase(), "");
			String curDir = url.getPath();

			if ((curDir.charAt(0) == '/') && curDir.toLowerCase().indexOf("c:") >= 0) {
				curDir = curDir.substring(1);
			}
			curDir = curDir.trim();
			curDir = curDir.replaceAll("%20", " ");
			dlgFormas = new HTLoadSVG((new URL(getCodeBase(), view.getFileShape())));
		} catch (Exception e) {
			System.out.println("Erro : " + e.toString());
		}

		view.criaDlgFormas(dlgFormas);

		if (htHintColor != null) {
			view.setHintColor(htHintColor);
		}
		if (htBackColor != null) {
			view.setBackColor(htBackColor);
		}
		if (htLinkColor != null) {
			view.setLinkColor(htLinkColor);
		}
		if (htSearchColor != null) {
			view.setSearchColor(htSearchColor);
		}
		if (htBorderType != null) {
			view.setBorderType(htBorderType);
		}
		if (htCenterNode != null) {
			view.setCenterNode(htCenterNode);
		}
		if (htHelpFile != null) {
			view.setHelpFile(htHelpFile);
		}
		
		if (htGraphColor != null) {
			view.setGraphColor(htGraphColor);
		}

		if (htLeafNode == null) {
			htLeafNode = "Box";
		}
		if (htLeafNode != null) {
			view.setLeafNode(htLeafNode);
		}

		if (htHasFolder == null) {
			htHasFolder = "true";
		}
		if (htHasFolder != null) {
			view.setHasFolder(htHasFolder);
		}

		// 14/11/2005
		if (htSearchType != null) {
			view.setSearchType(htSearchType.trim().toLowerCase());
		} else {
			view.setSearchType("line");
		}
		// *****

		if (htParentNode == null) {
			htParentNode = "Box";
		}
		if (htParentNode != null) {
			view.setParentNode(htParentNode);
		}
		if (htUrlAdr != null) {
			view.setUrlAdr(htUrlAdr);
		}
		if (htFont != null) {
			view.setFontNode(htFont);
		} else {
			view.setFontNode("Serif");
		}
		if (htFontSize != null) {
			view.setFontSizeNode(((new Integer(htFontSize)).intValue()));
		} else {
			view.setFontSizeNode(12);
		}
		if (htHomeImage != null) {
			imageH = getImage(getCodeBase(), htHomeImage);
			if (imageH != null) {
				view.setHomeImage(imageH);
			}
		} else {
		}

		if (htBackImage != null) {
			imageB = getImage(getCodeBase(), htBackImage);
			if (imageB != null) {
				view.setBackImage(imageB);
			}
		} else {
		}

		if (htOpenWindow != null) {
			view.setOpenWindow(htOpenWindow.toLowerCase());
		}

		if (htHelpImage != null) {
			imageS = getImage(getCodeBase(), htHelpImage);
			if (imageS != null) {
				view.setHelpImage(imageS);
			}
		} else {
		}

		// Swing - JPanel
		//Container content = getContentPane();
		//content.setLayout(new BorderLayout());
		//content.setBackground(Color.gray);
		//content.setSize(new Dimension(800, 600));
		//content.add("Center", view);
		//content.setVisible(true);
		// AWT - PAnel

		System.out.println("INIT 3");

		searchField = new TextField(10);
		searchField.setBackground(Color.lightGray);
		searchField.reshape(15, 20, 92, 24);
		
		view.setTextField(searchField);
		

		
		// **
		searchField.addTextListener(new HTListenerText(view));
		// this)); // **

		setLayout(new BorderLayout());

		setBackground(new Color(Color.decode(view.getBackColor()).getRGB()));

		//setSize(new Dimension(800, 600));

		//view.setTextField(searchField); // **
		//searchField.addTextListener(new HTListenerText(view)); // this)); // **

		add(searchField);
		
		//cb = new Checkbox("Mostrar linhas de Grafo", true);
		//view.setCheckBox(cb);    
		//cb.addChangeListener(changeListener);
		//add(cb);

		add("Center", view);

		searchField.reshape(15, 20, 92, 24);

		setVisible(true);

		//JFrame viewFrame = new JFrame(root.getName());
		//viewFrame.setContentPane(view);
		//viewFrame.pack();
		//viewFrame.setVisible(true);

	}


	/**
	 *  Description of the Method
	 *
	 * @param  node   Description of the Parameter
	 * @param  first  Description of the Parameter
	 */
	public void convertPixes2Image(HTFileNode node, boolean first) {

		if (first && node.getPixels() != null) {
			node.setImageFromPixels();
		}

		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNode = (HTFileNode) e.nextElement();
			if (!childNode.isLeaf()) {
				if (childNode.getPixels() != null) {
					childNode.setImageFromPixels();
				}
				convertPixes2Image(childNode, false);
			} else {
				if (childNode.getPixels() != null) {
					childNode.setImageFromPixels();
				}
			}
		}

	}


	/**
	 *  Description of the Method
	 */
	public void start() {
		//conteudo
		//init();
		System.out.println("START");
		//show();
		//requestFocus();
	}


	/**
	 *  Description of the Method
	 */
	public void stop() {
		//conteudo
		try {
			setVisible(false);
			System.out.println("STOP");
			destroy();
		} catch (Exception e) {
		}
	}


	// 12/09/2008
	/**
	 *  Sets the lineGraph attribute of the HTApplet object
	 *
	 * @param  n  The new lineGraph value
	 */
	public void setLineGraph(boolean n) {
		lineGraph = n;
	}


	/**
	 *  Gets the lineGraph attribute of the HTApplet object
	 *
	 * @return    The lineGraph value
	 */
	public boolean getLineGraph() {
		return lineGraph;
	}
	
	   public static HTFileNode findNo(HTFileNode no, String id) {
        if (no.getID().trim().equals(id.trim())) {
            return (no);
        }
        return buscaNo(no, id);
    }

    public void loadHint(String htFile ) {

		InputStream in = null;
		try {

			in = 
				new URL(getCodeBase(), htFile.toLowerCase().replaceAll(".htz", ".hnt")).openStream();
 			//	URL (  "http://www.kickjava.com"  ) .openStream (  ) ; 

                  InputStreamReader inR = new InputStreamReader (  in  ) ; 
   			BufferedReader buf = new BufferedReader (  inR  ) ; 
	
   			String line; 
			String id="";
			String value="";

			System.out.println (  " ***** Load Hint?"  ) ; 
			boolean achou=false;
  			while  (   (  line = buf.readLine (  )   )  != null  )   { 
				StringTokenizer stDatas1 = new StringTokenizer(line,";");

				if (stDatas1.hasMoreTokens()) {
					id=stDatas1.nextToken();
					id = id.trim();
				}
				if (stDatas1.hasMoreTokens()) {
					value=stDatas1.nextToken();
					value = value.trim();
					achou = true;
				}
				else
					achou = false;

				HTFileNode no = buscaNo(root, id);

				if (achou)
					no.setHint(value + " &crlf " + no.getHint());
				
     				System.out.println (  line  ) ; 			
   			}  
			if (in != null) in.close () ; 
  		}  
		catch (Exception e) {
			System.out.println("ERROR:"+e.toString());

		}

 
    }


    public void loadGraph(String htFile ) {

		InputStream in = null;
		try {

			in = 
				new URL(getCodeBase(), htFile.toLowerCase().replaceAll(".htz", ".grf")).openStream();

                  InputStreamReader inR = new InputStreamReader (  in  ) ; 
   			BufferedReader buf = new BufferedReader (  inR  ) ; 
	
   			String line; 
			String id="";
			String id1="";
			String value="";
			String name="";
			String lb="";
			String cl="";

			if (graph==null)
				graph = new HTVector();


			System.out.println (  " ***** Load Graf?"  ) ; 
			boolean achou=false;
  			while  (   (  line = buf.readLine (  )   )  != null  )   { 
				StringTokenizer stDatas1 = new StringTokenizer(line,";");

				achou = false;

				if (stDatas1.hasMoreTokens()) {
					id=stDatas1.nextToken();
					id = id.trim();
				}
				if (stDatas1.hasMoreTokens()) {
					id1=stDatas1.nextToken();
					id1 = id1.trim();
				}
				if (stDatas1.hasMoreTokens()) {
					value=stDatas1.nextToken();
					value = value.trim();
				}
				if (stDatas1.hasMoreTokens()) {
					lb = stDatas1.nextToken();
					lb = lb.trim();
					achou = true;
				}
				if (stDatas1.hasMoreTokens()) {
					cl=stDatas1.nextToken();
					cl = cl.trim();
					achou = true;
				}
				if (stDatas1.hasMoreTokens()) {
					name=stDatas1.nextToken();
					name = name.trim();
					achou = true;
				}
				

				HTFileNode no1 = findNo(root, id);
				HTFileNode no2 = findNo(root, id1);
				String gn="";

				if (no1 == null) 
					no1 = buscaNoByName(root, id);

				if (no2 == null) 
					no2 = buscaNoByName(root, id1);


				if (no1 != null && no2 != null) {
					
					HTPointGraph v = new HTPointGraph(no1, no2);

					if (achou && name != null && name.length() > 0)
						v.setArcName(name);
					else
						v.setArcName("");

					if (achou && value != null && value.trim().toLowerCase().equals("true"))
                        		v.setDirecionado(true);
					else
						v.setDirecionado(false);

					if (achou && lb != null && lb.length() > 0) {
						v.setGraphName(lb);
						gn = lb;
						//view.setGraphName(lb);
					}
					else {
						gn = "";
						v.setGraphName("");
					}

					if (achou && cl != null && cl.length() > 0) {
						v.setGraphColor(cl);
						view.setGraphName(gn, cl);
					}
					else {
						v.setGraphColor(view.getLinkColor());
						view.setGraphName(gn, view.getLinkColor());
					}
					
					graph.add((Object) v);
				}
				
   			}  
			if (in != null) in.close () ; 
  		}  
		catch (Exception e) {
			System.out.println("ERROR:"+e.toString());

		}

    }



    /**
     *  Description of the Method
     *
     * @param  node  Description of the Parameter
     * @param  id    Description of the Parameter
     * @return       Description of the Return Value
     */
    public static HTFileNode buscaNo(HTFileNode node, String id) {
        for (Enumeration e = node.children(); e.hasMoreElements();) {
            HTFileNode childNode = (HTFileNode) e.nextElement();
            if (childNode.getID().trim().equals(id.trim())) {
                return (childNode);
            }
            if (!childNode.isLeaf()) {

                HTFileNode ret = buscaNo(childNode, id);
                if (ret != null) {
                    return (ret);
                }
            }
        }
        return (null);
    }

    /**
     *  Description of the Method
     *
     * @param  node  Description of the Parameter
     * @param  id    Description of the Parameter
     * @return       Description of the Return Value
     */
    public static HTFileNode buscaNoByName(HTFileNode node, String id) {
        for (Enumeration e = node.children(); e.hasMoreElements();) {
            HTFileNode childNode = (HTFileNode) e.nextElement();
            if (childNode.getName().trim().equals(id.trim())) {
                return (childNode);
            }
            if (!childNode.isLeaf()) {

                HTFileNode ret = buscaNoByName(childNode, id);
                if (ret != null) {
                    return (ret);
                }
            }
        }
        return (null);
    }

    

   
	/*
	 *  public final void update(Graphics g)
	 *  {
	 *  super.paint(g);
	 *  }
	 *  public final void paint(Graphics g)
	 *  {
	 *  super.paint(g);
	 *  }
	 *  public void paint(Graphics g) {//conteudo
	 *  /g.setColor(Color.red);
	 *  /g.drawString("Eu sou uma applet",25,45);
	 *  /g.setColor(Color.green);
	 *  /g.drawString("que desenha um retangulo",45,75);
	 *  /g.setColor(Color.orange);
	 *  /g.drawRect(200,50,30,40);
	 *  view.paintComponent(g);
	 *  }
	 *  public void start() {//conteudo
	 *  show();
	 *  requestFocus();
	 *  }
	 */
}

