/*
 *  HTAction.java
 *
 *  www.bouthier.net
 *  2001
 */
//package hypertree;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
//import javax.swing.*;
import java.applet.*;
import java.io.*;

/**
 * The HTAction class manage the action on the hypertree :
 * drag of a node...
 *
 * @author     silvio
 * @created    29 de Setembro de 2004
 */

/*
 *  Antes:
 *  class HTAction
 *  extends MouseAdapter
 *  implements MouseMotionListener  {
 */
class HTAction
//extends MouseAdapter
		 implements Serializable, MouseMotionListener, MouseListener, KeyListener {

	private HTDraw model = null;
	// the drawing model
	private HTNodeLabel label = null;
	private HTCoordE startPoint = null;
	// starting point of dragging
	private HTCoordE endPoint = null;
	// ending point of dragging
	private HTCoordS clickPoint = null;
	// clicked point
	private HTDrawNode node;
	private HTDrawNode nodeA;
	private HTDrawNode nodeAA=null;
	private HTDrawNode nodeH = null;
	/**
	 *  Description of the Field
	 */
	protected volatile int fClickCount;
	/**
	 *  Description of the Field
	 */
	protected volatile String nodeID = "";
	/**
	 *  Description of the Field
	 */
	protected volatile String nodeID_A = "";
	private Applet applet;
	private static boolean isDragged = false;

	private static int pxdrag=-1;
	private static int pydrag=-1;



	/*
	 *  --- Constructor ---
	 */
	/**
	 * Constructor.
	 *
	 * @param  model    the drawing model
	 * @param  jApplet  Description of the Parameter
	 */
	HTAction(HTDraw model, Applet jApplet) {
		this.model = model;
		startPoint = new HTCoordE();
		endPoint = new HTCoordE();
		clickPoint = new HTCoordS();
		applet = jApplet;
	}


	/*
	 *  --- MouseAdapter ---
	 */
	/**
	 * Called when a user pressed the mouse button
	 * on the hyperbolic tree.
	 * Used to get the starting point of the drag.
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */
	public void mousePressed(MouseEvent e) {
		if (e.isShiftDown()) {
			model.fastMode(true);
		}
		model.setHint(false);
		isDragged = true;

		startPoint.projectionStoE(e.getX(), e.getY(), model);

		pxdrag=e.getX();
		pydrag=e.getY();
	}

	/**
	 * Called when a user release the mouse button
	 * on the hyperbolic tree.
	 * Used to signal the end of the translation.
	 *
	 * @param  e  not used here
	 */
	public void mouseReleased(MouseEvent e) {
		model.fastMode(false);
		model.endTranslation();
		isDragged = false;

		if ((Math.abs(pxdrag-e.getX())<=20) &&
		    (Math.abs(pydrag-e.getY())<=20))
			mouseClicked(e); 
	}

	/**
	 * Called when a user move mouse over a node on the hyperbolic tree.
	 * Used to put a hint on the corresponding node (if any) at the
	 * bellowf of the node.
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */
	public void mouseEntered(MouseEvent e) {
	}

	/**
	 * Called when a user move mouse goes off a node on the hyperbolic tree.
	 * Used to drop a hint on the corresponding node (if any).
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */
	public void mouseExited(MouseEvent e) {
	}


	/*
	 *  Conta quantos links tem na string
	 */
	/**
	 *  Description of the Method
	 *
	 * @param  URLs  Description of the Parameter
	 * @return       Description of the Return Value
	 */
	int ContaLinks(String URLs) {
		int NumLinks = 0;
		if (URLs == null || URLs.trim().length() < 1) 
			return 0;
		for (int i = 0; i < URLs.length(); i++) {
			if (URLs.charAt(i) == '@') {
				NumLinks++;
			}
		}
		if (NumLinks == 0)
			NumLinks++;
		
		return NumLinks;
	}

	/**
	 * Called when a user clicked on the hyperbolic tree.
	 * Used to put the corresponding node (if any) at the
	 * center of the hyperbolic tree.
	 *
	 * @param  e  the MouseEvent generated when clicking
	 */

  int dClkRes = 1000;    // double-click speed in ms
  long timeMouseDown=0; // last mouse down time
  int lastX=0,lastY=0; 
  
   int jaExecutou=0;
   
   Frame f=null;
  

	public void mouseClicked(MouseEvent e) {
		
		if (f != null) {
			f.dispose();
		}
		
		model.setHint(false);

		if (e.isShiftDown()) {
			model.restore();
		} else {

			clickPoint.x = e.getX();
			clickPoint.y = e.getY();

/*
    long currentTime = e.getWhen();
    if (
        (Math.abs(lastX-clickPoint.x) <= 40) && (Math.abs(lastY-clickPoint.y) <= 40) && ((e.getWhen()-timeMouseDown) <= dClkRes)
       ) {
        System.out.println("double click " + currentTime);    
    }
    else {
        //single click action could be added here
        System.out.println("simple click " + currentTime);
        timeMouseDown = e.getWhen();
        lastX=clickPoint.x ;
        lastY=clickPoint.y;
    }
*/
			node = model.findNode(clickPoint); // Ponto a melhorar. talvez colocar um percentual de erro no toque (5%)

			/*
			 *  Bruno
			 *  Verifica se o botao direito foi pressionado e abre a janela se nao for uma folha
			 */
			//if (e.getButton() == 3 && node != null && !node.isLeafNode()) {

			if (e.getButton() == 3 && node != null) {
				f = new Frame("Opcoes");
				//Frame f = new Frame("Opcoes");

				HTDialogOpcoes opt;

				if (!node.isLeafNode())
					opt = new HTDialogOpcoes(f, node, 0, model);
				else
					opt = new HTDialogOpcoes(f, node, 1, model);

				opt.show();
			
				// 
				model.folderFechadoGraphLine(node);				
				//model.reDraw();
			}

			// Verifica se foi o botao esquerdo
			if (e.getButton() == 1) {
				// 13/09/2004

				// END

				if (node == null) {
					if (jaExecutou==1) {
						jaExecutou=0;
						fClickCount = 0;	
						return;
					}
					else {
						jaExecutou=1;
					}
					int res = model.verifyHomeClick(clickPoint);

					if (res == 1) {
						// Asking for Help
						String help = model.getHelpFile();

						if (help.length() > 2) {
							boolean UrlOnError = false;
							URL userUrl = null;
							try {
								userUrl = new URL(help);
							} catch (Exception urlError) {
								UrlOnError = true;
							}
							if (!UrlOnError) {
								applet.getAppletContext().showDocument(userUrl, "_blank");
							}
						}
					}
					
					res = model.verifyGraphLine(clickPoint);
					
					if (res == 1) {
						model.setViewLineGraph();	
					}
					if (res == 2)
						model.reDraw();
				}
				// Bruno - && (node != null)
				if (node == null)
					return;
				if ((fClickCount = e.getClickCount()) == 1 &&
						(node != null)) {
					fClickCount = e.getClickCount();
/*
					new Thread(
						new Runnable() {
							public void run() {
								try {

									Thread.sleep(500);
									if (fClickCount == 1) {

										fClickCount = 0;
										//if (node != null) {

										// Silvio em 28/09/2004
										// Vou verificar se o n  do tipo link escondido

										int posH = node.getID().indexOf("_H_");
										if (posH >= 0) {
											HTDrawNode nodeC;
											String idNode = node.getID().substring(0, posH);
											if (!node.getFather().getID().equals(idNode)) {
												nodeC = model.findNode(idNode);
											}
											else {
												idNode = node.getID().substring(posH+3);
												nodeC = model.findNode(idNode);
											}

											if (nodeC != null) {
												model.executaSearchWord(node.getID());
												//idNode);
												model.translateToOrigin(nodeC);
												nodeH = node;
											}
										} else {

											posH = -1;

											if (nodeH != null) {
												posH = nodeH.getID().indexOf("_H_");
											}

											if (posH >= 0) {
												String idNode = nodeH.getID().substring(0, posH);
												if (node.getID().compareTo(idNode) == 0) {
													model.translateToOrigin(nodeH);
												} else {
													model.translateToOrigin(node);
												}

												nodeH = null;
												model.executaSearchWord("");

											} else {
												model.translateToOrigin(node);
											}
										}

										// **** SILVIO

										//} bruno
									} else {
*/

if (fClickCount == 1) {

										if (node != null) {

										boolean UrlOnError = false;
										URL userUrl = null;
										String adr;
										boolean vazia = true;

										adr = node.getURL();

										/*
										 *  BRUNO
										 *  Popup que mostra os links disponiveis para esse no caso existe mais que um
										 */
										boolean clickOnImage = model.getClickOnImage();

										if (!clickOnImage && ContaLinks(adr) > 1) {
											Frame f = new Frame();
											HTDialogLinks MessageLinks = new HTDialogLinks(f, node, model, applet);
											// Mostra a mensagem
											MessageLinks.show();
										}
										/*
										 *  Se existir apenas 1 link, ja abre o endereco no browser
										 */else {

											if ((adr != null) && (adr.trim().length() > 2)) {
												vazia = false;
												int pi = adr.indexOf("`");
												if (pi > 0)
													adr = adr.substring(0, pi);
											}

											String base = model.getUrlAdr();

											//System.out.println("Imagem ? " + clickOnImage);
											
											if (jaExecutou==1) {
												jaExecutou=0;
												fClickCount = 0;	
												return;
											}
											else {
												jaExecutou=1;
											}
											
											if (clickOnImage) {
												try {
													// Abrir Imagem associada ao n: 
													if ( node.getNameImage().indexOf("/")>0)
														userUrl = new URL(applet.getCodeBase(), node.getNameImage());
													else
														userUrl = new URL(applet.getCodeBase(), "imagens/" + node.getNameImage());
													//userUrl = new URL(applet.getCodeBase(), node.getNameImage());
													vazia = false;
												} catch (Exception urlError) {
													UrlOnError = true;
												}

											} else {

												if ((base.length() > 2) && ((adr.toLowerCase().indexOf("http:") < 0) && (adr.toLowerCase().indexOf("file:") < 0))) {
													if ((!vazia) && (adr.charAt(0) != '/')) {
														adr = base + "/" + adr;
													} else {
														adr = base + adr;
													}
												}

												if ((base.length() <= 2) && ((adr.toLowerCase().indexOf("http:") < 0) && (adr.toLowerCase().indexOf("file:") < 0))) {
													try {
														System.out.println(applet.getCodeBase() + " " + adr);
														userUrl = new URL(applet.getCodeBase(), adr);
														System.out.println("OK");
														
													} catch (Exception urlError) {
														UrlOnError = true;
														System.out.println("OK");
													}
												} else {
													try {
														System.out.println(adr);
														userUrl = new URL(adr);
														
													} catch (Exception urlError) {
														UrlOnError = true;
													}
												}
											}

											if ((!UrlOnError) && (!vazia)) {
												if (model.getOpenWindow().trim().equals("self")) {
													System.out.println("_parent");
													applet.getAppletContext().showDocument(userUrl, "_parent");
												} else {
													System.out.println("_blank");
													applet.getAppletContext().showDocument(userUrl, "_blank");
												}

											} else {
												System.out.println("URL Invlida " + adr);
											}
										}
										fClickCount = 0;										
										}
									}
/*
								} catch (Exception ex) {
								} finally {
								}
							}
						}).start();
*/
				}
			}
		}

	}


	/*
	 *  --- MouseMotionListener ---
	 */
	/**
	 * Called when a used drag the mouse on the hyperbolic tree.
	 * Used to translate the hypertree, thus moving the focus.
	 *
	 * @param  e  the MouseEvent generated when draging
	 */
	public void mouseDragged(MouseEvent e) {
		
		if (f != null) {
			f.dispose();
		}

		model.setHint(false);
		model.fastMode(true);
		isDragged = true;

		if (startPoint.isValid()) {
			endPoint.projectionStoE(e.getX(), e.getY(), model);
			if (endPoint.isValid()) {
				model.translate(startPoint, endPoint);
			}
		}
	}

	/**
	 * Called when the mouse mouve into the hyperbolic tree.
	 * Not used here.
	 *
	 * @param  e  the MouseEvent generated when mouving
	 */
	public void mouseMoved(MouseEvent e) {
		
		Point pt = e.getPoint();

		clickPoint.x = pt.x;
		clickPoint.y = pt.y;

		if ((fClickCount > 0) || (isDragged)) {
			if (nodeA != null) {
				// silvio
				nodeA.setEspecialMark(false);
				nodeA.setHasHint(false);
				model.setHint(false);
				model.reDraw();
			}
			//System.out.println("* 1");
			return;
		}

		if (node == null) {
			if (nodeA != null) {
				// silvio
				nodeA.setEspecialMark(false);
				nodeA.setHasHint(false);
				model.setHint(false);
				model.reDraw();
			}
			nodeA = null;
		} else {
			if (nodeID.equals(nodeID_A) == false) {
				if (nodeA != null) {
					nodeA.setHasHint(false);
					model.setHint(false);
					model.reDraw();
				}
				nodeA = node;
				nodeID_A = nodeID;
			}
		}

		node = model.findNode(clickPoint);

		if(node != null) {
			String adr = node.getURL();
			/** Se existe um link, muda o cursor para mao */
			if(ContaLinks(adr) > 0) {
				/** Se ja for a mao, nao muda */
				if(applet.getCursor().getType() != Cursor.HAND_CURSOR)
					applet.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
			} else {
				/** Se ja for o default nao muda */
				if(applet.getCursor().getType() != Cursor.DEFAULT_CURSOR)
					applet.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}
		} else {
			/** Se ja for o default nao muda */
			if(applet.getCursor().getType() != Cursor.DEFAULT_CURSOR) {
				applet.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}
		}
				
		boolean clickOnImage = model.getClickOnImage();

		if (clickOnImage) {
			if (nodeA != null) {
				// silvio
				nodeA.setEspecialMark(false);
				nodeA.setHasHint(false);
				model.setHint(false);
				model.reDraw();
			}
			return;
		}
		if (node != null) {
			if (nodeA != null) {
				nodeA.setEspecialMark(false);
			}

			node.setEspecialMark(true);
			
			// 06/10/2009
			//node.setHasHint(true);
			//model.setHint(true);
			// *** END ****

			if ((nodeID.equals(nodeID_A)) || (nodeID_A.equals(""))) {
				nodeID_A = nodeID;
			} else {
				nodeID_A = "";

			}
			nodeID = node.getID();

		} else {
			if (nodeA != null) {
				nodeA.setEspecialMark(false);
				nodeA.setHasHint(false);
				model.setHint(false);
				model.reDraw();
			}

			nodeID_A = nodeID;
			nodeID = "";

		}

		if (node != null) {
			new Thread(
				new Runnable() {

					public void run() {
						try {
							if ((nodeID_A.equals("")) || (nodeID.equals(nodeID_A))) {
								Thread.sleep(600);
								if ((fClickCount > 0) || (isDragged)) {
									// 06/10/2009									
									node.setHasHint(false);
									model.setHint(false);
									return;
								}
								if ((nodeID.equals("") == false) && (nodeID.equals(nodeID_A))) {
									// 06/10/2009
									if (nodeAA != null) {
										nodeAA.setHasHint(false);
									}
									node.setHasHint(true);
									model.setHint(true);
									nodeAA=node;
								}
							}
							model.reDraw();
						} catch (Exception ex) {
						} finally {
						}
					}
				}).start();
		}
	}

	/**
	 *  Description of the Method
	 *
	 * @param  ev  Description of the Parameter
	 */
	public void keyTyped(KeyEvent ev) {
		//System.out.println("key typed: " + ev.getKeyChar());
	}

	/**
	 *  Description of the Method
	 *
	 * @param  ev  Description of the Parameter
	 */
	public void keyPressed(KeyEvent ev) {
		/*
		 *  int code = ev.getKeyCode();
		 *  switch (code) {
		 *  case KeyEvent.VK_UP:
		 *  System.out.println("Up key");
		 *  break;
		 *  case KeyEvent.VK_DOWN:
		 *  System.out.println("Down key");
		 *  break;
		 *  case KeyEvent.VK_LEFT:
		 *  System.out.println("Left key");
		 *  break;
		 *  case KeyEvent.VK_RIGHT:
		 *  System.out.println("Right key");
		 *  break;
		 *  case KeyEvent.VK_ALT:
		 *  System.out.println("1.) ALT com a tecla "+ ev.getKeyChar());
		 *  break;
		 *  case KeyEvent.VK_CONTROL:
		 *  System.out.println("CONTROL");
		 *  break;
		 *  default: System.out.println("Key press ignored");
		 *  }
		 *  if (ev.isAltDown())
		 *  System.out.println("Key Pressed "+ ev.getKeyChar());
		 */
	}

	/**
	 *  Description of the Method
	 *
	 * @param  ev  Description of the Parameter
	 */
	public void keyReleased(KeyEvent ev) {

		int code = ev.getKeyCode();
		switch (code) {
						case KeyEvent.VK_ESCAPE:

							if (nodeH != null) {
								model.translateToOrigin(nodeH);
								nodeH = null;
								model.executaSearchWord("");
							}

							break;
						/*
						 *  case KeyEvent.VK_DOWN:
						 *  System.out.println("Down key");
						 *  break;
						 *  case KeyEvent.VK_LEFT:
						 *  System.out.println("Left key");
						 *  break;
						 *  case KeyEvent.VK_RIGHT:
						 *  System.out.println("Right key");
						 *  break;
						 *  case KeyEvent.VK_ALT:
						 *  System.out.println("1.) ALT com a tecla "+ ev.getKeyChar());
						 *  break;
						 *  case KeyEvent.VK_CONTROL:
						 *  System.out.println("CONTROL");
						 *  break;
						 *  default: System.out.println("Key press ignored");
						 */
		}
		if (ev.isAltDown()) {
			System.out.println("Key Pressed " + ev.getKeyChar());
		}
	}
}

