/*
 *  HTGeodesic.java
 *  www.bouthier.net
 *
 *  The MIT License :
 *  -----------------
 *  Copyright (c) 2001 Christophe Bouthier
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a
 *  copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *  and/or sell copies of the Software, and to permit persons to whom the
 *  Software is furnished to do so, subject to the following conditions:
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 *  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 *  OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 *  ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 *  DEALINGS IN THE SOFTWARE.
 */
// Cdigo alterado por Silvio Evangelista

//package hypertree;

import java.awt.*;

//import javax.swing.*;
import java.applet.*;
import java.util.*;

/**
 * The HTView class implements a view of the HyperTree.
 *
 * @author     silvio
 * @created    15 de Setembro de 2008
 */
public class HTView
		 extends HTDoubleBuffer {
	// JPanel or Panel

	private HTModel model = null;
	// the tree model represented
	private HTDraw draw = null;
	// the drawing model
	private HTAction action = null;
	// action manager
	private boolean hasHint = false;
	private TextField textField;
	private String vString[] = new String[16];
	private int nAnds = 0;
	//private Checkbox cb;

	private boolean isSearch = false;
	private String hintColor = "0xF0FFF0";
	private String centerNode = null;
	private String backColor = "0xDDDDDD";
	// 17/11/2005
	private int backRed;
	private int backGreen;
	private int backBlue;
	// *******
	private String linkColor = "0x000000";
	private String searchColor = "0xFF0000";
	private String graphColor = "0x000000";

	private String borderType = "normal";
	private String helpFile = "";
	private String urlAdr = "";
	private String openWindow = "new";
	private String leafNode = "Box";
	private String parentNode = "Box";
	private String labelCount = "Total de Folhas:";
	private String sumTags = "";
	private boolean hasFolder = true;
	private boolean searchType = false;
	// 14/11/2005


	private String fontNode = "serif";
	private int fontSize = 12;
	private boolean isFirstTime = true;
	private Image imageH;
	private Image imageB;
	private Image imageS;
	private Rectangle rect;
      Vector graphNames = null;

	/**
	 *  Description of the Field
	 */
	public HTLoadSVG dlgFormas;
	private String nameShape = "";
	private HTVector graph = null;
	//12/08/2009
	private boolean lineGraph = true;


	/*
	 *  --- Constructor ---
	 */
	/**
	 * Constructor.
	 *
	 * @param  model    the tree model to view
	 * @param  jApplet  Description of the Parameter
	 */
	public HTView(HTModel model, Applet jApplet) {
		//super(new BorderLayout());
		//setLayout(null);
		//setLayout(new BorderLayout());
		//setSize(new Dimension(800, 600));
		//validate();
		//setBackground(Color.white);
		//super(new BorderLayout());
		//setPreferredSize(new Dimension(250, 250));

		this.model = model;
		draw = new HTDraw(model, this);
		action = new HTAction(draw, jApplet);

		graphNames = new Vector(); 	

		startMouseListening();

	}


	void setGraphName(String v, String cl) {

		HTLabelGraph u;
		String s;
		boolean achou=false;

		for (int i=0; i < graphNames.size(); i++) {
			s = getGraphNameI(i);

			if (s.equals(v.toUpperCase().trim()))
				achou = true;
		}
		if (!achou) {
			u = new HTLabelGraph(v.toUpperCase().trim(), false, cl);
			graphNames.add((Object) u);
		}
	}

	String getGraphNameI(int i) {
		HTLabelGraph u;

		if (graphNames.size() > i) {	
			u = (HTLabelGraph) graphNames.elementAt(i);
			return u.getName();
		}
		else
			return "";
	}

	boolean getGraphShowI(int i) {
		HTLabelGraph u;

		if (graphNames.size() > i) {	
			u = (HTLabelGraph) graphNames.elementAt(i);
			return u.getShow();
		}
		else
			return false;
	}

	String getGraphColorI(int i) {
		HTLabelGraph u;

		if (graphNames.size() > i) {	
			u = (HTLabelGraph) graphNames.elementAt(i);
			return u.getColor();
		}
		else
			return linkColor;
	}


	void setGraphShowI(int i, boolean b) {
		HTLabelGraph u;

		if (graphNames.size() > i) {	
			u = (HTLabelGraph) graphNames.elementAt(i);
			String s = u.getName();
			u.setShow(b);

			// Definir atributo mostra dos grafos (true or false)
			for (int j=0; j < graph.size(); j++) {
				HTPointGraph v = (HTPointGraph) graph.elementAt(j);
				if (v.getGraphName().toUpperCase().trim().equals(s.toUpperCase().trim())) {
					v.setShowGroup(b);
				}
			}
		}
	}


	boolean verifyGraphShow(String v) {
		HTLabelGraph u;
		String s="";

		for (int i=0; i < graphNames.size(); i++) {
			u = (HTLabelGraph) graphNames.elementAt(i);
			s = u.getName();
			if (s.equals(v.toUpperCase().trim()))
				return u.getShow();
		}
		return false;
	}



	int getGraphNameSize(){
		return graphNames.size();
	}


	/*
	 *  --- Paint ---
	 */
	/**
	 * Paint the component.
	 *
	 * @param  g  the graphic context
	 */

	public void paintBuffer(Graphics g) {
		//paint
		//super.paint(g);

		//stopMouseListening();

		int x;
		//paint
		//super.paint(g);

		//stopMouseListening();

		int y;

		x = 15;
		y = 50;
/*
		if (nGraphLines() > 0) {
			g.setColor(new Color(Color.decode(lineColor).getRGB()));
			if (getViewLineGraph()) {
				g.fillRect(15, 50, 12, 12);
			} else {
				g.drawRect(15, 50, 12, 12);
			}
			g.drawString("Mostrar linhas de grafo", 32, 62);

			int ng_x = 15;
			int ng_y = 72;

			for (int nlg=0; nlg < graphNames.size(); nlg++) {
				if (getGraphShowI(nlg)) {
					g.fillRect(ng_x, ng_y, 12, 12);
				} else {
					g.drawRect(ng_x, ng_y, 12, 12);
				}
				g.drawString(getGraphNameI(nlg), 32, ng_y + 12);

				ng_y = ng_y + 22;
 
			}

		}
*/
		if (imageB != null) {
			g.drawImage(imageB, (getSize().width / 2) - imageB.getWidth(this) / 2, (getSize().height / 2) - imageB.getHeight(this) / 2, this);
		}

		draw.refreshScreenCoordinates();

		draw.drawBranches(g);

		draw.drawNodes(g);

		if (imageH != null) {
			rect = new Rectangle(x, y, imageH.getWidth(this), imageH.getHeight(this));
			g.drawImage(imageH, rect.x, rect.y, this);
			if (getCenterNode() != null) {
				g.drawImage(imageH, rect.x + rect.width, rect.y, this);
			}
		}

		if (imageS != null) {
			if (getCenterNode() != null) {
				g.drawImage(imageS, (rect.x * 3 + rect.width), rect.y, this);
			} else {
				g.drawImage(imageS, (rect.x * 3 + rect.width), rect.y, this);
			}
		}

		if (hasHint) {
			draw.drawHint(g);
		}

		if ((isFirstTime) && (centerNode != null)) {
			isFirstTime = false;
			HTDrawNode nodeC = draw.findNode(centerNode.toLowerCase());
			if (nodeC != null) {
				draw.translateToOrigin(nodeC);
			}
			repaint();
		}
		//startMouseListening();

	}


	/**
	 *  Sets the viewLineGraph attribute of the HTView object
	 *
	 */
	public void setViewLineGraph() {
		lineGraph = !lineGraph;

		String search = getSearchWord();

		if ((search == null) || (search.length() == 0)) {
			isSearch = false;
		} else {
			isSearch = true;
		}

		model.setIsSearchText(isSearch);

		HTModelNode nodeD = model.getRoot();

		searchText(nodeD.getHTnode(), search.toLowerCase());

		repaint();
	}


	/**
	 *  Gets the viewLineGraph attribute of the HTView object
	 *
	 * @return    The viewLineGraph value
	 */
	public boolean getViewLineGraph() {
		return lineGraph;
	}


	/**
	 *  Sets the leafNode attribute of the HTView object
	 *
	 * @param  v  The new leafNode value
	 */
	public void setLeafNode(String v) {
		leafNode = v;
	}


	/**
	 *  Gets the leafNode attribute of the HTView object
	 *
	 * @return    The leafNode value
	 */
	public String getLeafNode() {
		return leafNode;
	}


	/**
	 *  Sets the parentNode attribute of the HTView object
	 *
	 * @param  v  The new parentNode value
	 */
	public void setParentNode(String v) {
		parentNode = v;
	}


	/**
	 *  Gets the parentNode attribute of the HTView object
	 *
	 * @return    The parentNode value
	 */
	public String getParentNode() {
		return parentNode;
	}


	/**
	 *  Sets the helpImage attribute of the HTView object
	 *
	 * @param  i  The new helpImage value
	 */
	public void setHelpImage(Image i) {
		imageS = i;
	}


	/**
	 *  Sets the homeImage attribute of the HTView object
	 *
	 * @param  i  The new homeImage value
	 */
	public void setHomeImage(Image i) {
		imageH = i;
	}


	/**
	 *  Sets the backImage attribute of the HTView object
	 *
	 * @param  i  The new backImage value
	 */
	public void setBackImage(Image i) {
		imageB = i;
	}


	/**
	 *  Gets the homeRect attribute of the HTView object
	 *
	 * @return    The homeRect value
	 */
	public Rectangle getHomeRect() {
		return rect;
	}


	/**
	 * Set the graphics has a hint.
	 *
	 * @param  v  The new hasHint value
	 */

	public void setHasHint(boolean v) {
		hasHint = v;
	}


	/**
	 * Set the hint color of the nodes
	 *
	 * @param  color  The new hintColor value
	 * @Param         String RGB color ("0xFFFFFF")
	 */

	void setHintColor(String color) {
		hintColor = color;
	}


	/**
	 * Returns the hint color armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @return    String of RGB color
	 */

	String getHintColor() {
		return hintColor;
	}


	/**
	 * Set the id of the center node of the tree
	 *
	 * @param  nodeID  The new centerNode value
	 * @Param          String
	 */

	void setCenterNode(String nodeID) {
		centerNode = nodeID;
	}


	/**
	 * Returns the id of center node armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @return    String of RGB color
	 */

	String getCenterNode() {
		return centerNode;
	}


	/**
	 * Set the border type of the nodes
	 *
	 * @param  bd  The new labelCount value
	 * @Param      String
	 */

	void setLabelCount(String bd) {
		labelCount = bd;
	}


	/**
	 *  Sets the sumTags attribute of the HTView object
	 *
	 * @param  v  The new sumTags value
	 */
	void setSumTags(String v) {
		sumTags = v;
	}


	/**
	 *  Gets the labelCount attribute of the HTView object
	 *
	 * @return    The labelCount value
	 */
	String getLabelCount() {
		return labelCount;
	}


	/**
	 *  Gets the sumTags attribute of the HTView object
	 *
	 * @return    The sumTags value
	 */
	String getSumTags() {
		return sumTags;
	}


	/**
	 *  Sets the borderType attribute of the HTView object
	 *
	 * @param  bd  The new borderType value
	 */
	void setBorderType(String bd) {
		borderType = bd;
	}


	/**
	 *  Sets the helpFile attribute of the HTView object
	 *
	 * @param  v  The new helpFile value
	 */
	void setHelpFile(String v) {
		helpFile = v;
	}


	/**
	 *  Sets the urlAdr attribute of the HTView object
	 *
	 * @param  v  The new urlAdr value
	 */
	void setUrlAdr(String v) {
		urlAdr = v;
	}


	/**
	 *  Gets the helpFile attribute of the HTView object
	 *
	 * @return    The helpFile value
	 */
	String getHelpFile() {
		return helpFile;
	}


	/**
	 *  Gets the urlAdr attribute of the HTView object
	 *
	 * @return    The urlAdr value
	 */
	String getUrlAdr() {
		return urlAdr;
	}


	/**
	 *  Gets the hasFolder attribute of the HTView object
	 *
	 * @return    The hasFolder value
	 */
	boolean getHasFolder() {
		return hasFolder;
	}


	/**
	 *  Sets the hasFolder attribute of the HTView object
	 *
	 * @param  v  The new hasFolder value
	 */
	void setHasFolder(String v) {
		if (v.trim().toUpperCase().indexOf("TRUE") >= 0) {
			hasFolder = true;
		} else {
			hasFolder = false;
		}
	}



	/**
	 * Returns the border type of the node
	 *
	 * @return    String
	 */

	String getBorderType() {
		return borderType;
	}


	/**
	 * Set the back color of the nodes
	 *
	 * @param  color  The new backColor value
	 * @Param         String RGB color ("0xFFFFFF")
	 */

	void setBackColor(String color) {
		backColor = color;
		// 17/11/2005
		backRed = Color.decode(backColor).getRed();
		backGreen = Color.decode(backColor).getGreen();
		backBlue = Color.decode(backColor).getBlue();
		// ****


	}


	/**
	 * Returns the hint color armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @return    String of RGB color
	 */

	String getBackColor() {
		return backColor;
	}


	// 17/11/2005
	/**
	 *  Gets the backRed attribute of the HTView object
	 *
	 * @return    The backRed value
	 */
	int getBackRed() {

		return backRed;
	}


	/**
	 *  Gets the backGreen attribute of the HTView object
	 *
	 * @return    The backGreen value
	 */
	int getBackGreen() {

		return backGreen;
	}


	/**
	 *  Gets the backBlue attribute of the HTView object
	 *
	 * @return    The backBlue value
	 */
	int getBackBlue() {
		return backBlue;
	}


// ******

	/**
	 * Set the link color of the nodes
	 *
	 * @param  color  The new linkColor value
	 * @Param         String RGB color ("0xFFFFFF")
	 */

	void setLinkColor(String color) {
		linkColor = color;
	}


	/**
	 * Returns the hint color armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @return    String of RGB color
	 */

	String getLinkColor() {
		return linkColor;
	}


	/**
	 *  Sets the openWindow attribute of the HTView object
	 *
	 * @param  v  The new openWindow value
	 */
	void setOpenWindow(String v) {

		openWindow = v;
	}


	/**
	 *  Gets the openWindow attribute of the HTView object
	 *
	 * @return    The openWindow value
	 */
	String getOpenWindow() {
		return openWindow;
	}


	/**
	 * Set the search color of the nodes
	 *
	 * @param  color  The new searchColor value
	 * @Param         String RGB color ("0xFFFFFF")
	 */

	void setSearchColor(String color) {
		searchColor = color;
	}


	/**
	 * Returns the hint color armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @return    String of RGB color
	 */

	String getSearchColor() {
		return searchColor;
	}


	/**
	 * Set the name of the font armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @param  font  The new fontNode value
	 */

	void setFontNode(String font) {
		fontNode = font;
	}


	/**
	 * Returns the name of the font armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @return    String
	 */

	String getFontNode() {
		return fontNode;
	}


	/**
	 * Set size of the font armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @param  value  The new fontSizeNode value
	 */

	void setFontSizeNode(int value) {
		fontSize = value;
	}


	/**
	 * Returns the size of the font armazened in view class
	 * contains thoses given in parameters.
	 *
	 * @return    int
	 */

	int getFontSizeNode() {
		return fontSize;
	}



	/*
	 *  --- Thread-safe locking ---
	 */
	/**
	 * Stops the listening of mouse events.
	 */
	void stopMouseListening() {
		this.removeMouseListener(action);
		this.removeMouseMotionListener(action);
		this.removeKeyListener(action);

	}


	/**
	 * Starts the listening of mouse events.
	 */
	void startMouseListening() {
		this.addMouseListener(action);
		this.addMouseMotionListener(action);
		this.addKeyListener(action);

	}


	/**
	 * Set the value of text field (finds field)
	 *
	 * @param  t  The new textField value
	 */

	void setTextField(TextField t) {
		textField = t;
	}



	/**
	 * find the string S on all node of the tree
	 *
	 * @param  node  Description of the Parameter
	 * @param  s     Description of the Parameter
	 */

	public void searchText(HTNode node, String s) {

		String s1 = " " + s;

		boolean found = false;
		int id;

		node.setHasArc(false);
		node.setHasData(false);

		parserToken(s);

		int posHNode = node.getID().indexOf("_H_");
		int posH = s.toUpperCase().indexOf("_H_");
		String s2 = "";
		if (posH >= 0) {
			s2 = s.substring(0, posH);
		} else {
			s2 = s;
		}
		if (posH > 0) {
			if ((isSearch) && node.getID().toUpperCase().startsWith(s2.toUpperCase())) {
				found = true;
			}
		}
		if (posH < 0) {
			if (posHNode < 0 || (posHNode > 0 && !lineGraph)) {
				if ((isSearch) && searchToken(node.getName())) {
					found = true;
				}
				if ((isSearch) && (!found) && searchToken(node.getHint())) {
					found = true;
				}
			}
		}

		if (found) {
			node.setHasData(true);
		}

		for (Enumeration e = node.childrenNode(); e.hasMoreElements(); ) {
			HTNode childNode = (HTNode) e.nextElement();

			childNode.setHasData(false);
			childNode.setHasArc(false);

			if (childNode != null) {
				if (!childNode.isLeafNode()) {
					searchText(childNode, s);
					if ((childNode.getHasData()) || (childNode.getHasArc())) {
						node.setHasArc(true);
					}
				} else {
					found = false;

					posH = s.toUpperCase().indexOf("_H_");
					posHNode = childNode.getID().indexOf("_H_");
					s2 = "";
					if (posH >= 0) {
						s2 = s.substring(0, posH);
					} else {
						s2 = s;
					}
					if (posH > 0) {
						if ((isSearch) && childNode.getID().toUpperCase().startsWith(s2.toUpperCase())) {
							found = true;
						}
					}
					if (posH < 0) {
						if (posHNode < 0 || (posHNode > 0 && !lineGraph)) {
							if ((isSearch) && searchToken(childNode.getName())) {
								found = true;
							}
							if ((isSearch) && (!found) && searchToken(childNode.getHint())) {
								found = true;
							}
						}
					}

					if (found) {
						childNode.setHasData(true);
						node.setHasArc(true);
					}
				}

			}
		}

	}


	// Silvio: 29/09/2004

	/**
	 *  Description of the Method
	 *
	 * @param  search  Description of the Parameter
	 */
	String searchG = "";


	/**
	 *  Description of the Method
	 *
	 * @param  search  Description of the Parameter
	 */
	void executaSearchWord(String search) {

		if ((search == null) || (search.length() == 0)) {
			isSearch = false;
		} else {
			isSearch = true;
		}

		searchG = search;

		model.setIsSearchText(isSearch);
		// 14/11/2005

		HTModelNode nodeD = model.getRoot();

		searchText(nodeD.getHTnode(), search.toLowerCase());

		repaint();

	}


	// *** Silvio

	/**
	 *  Description of the Method
	 *
	 * @param  v  Description of the Parameter
	 * @return    Description of the Return Value
	 */
	boolean searchToken(String v) {
		String s1;
		String s2;
		String s3;
		String s4;
		String s5;
		String s6;
		String s;
		int nFound = 0;
		int id;
		v = v.toLowerCase();

		for (int i = 0; i < nAnds; i++) {
			s = vString[i];
			s1 = " " + s;
			s2 = "," + s;
			//s3 = ";" + s;
			//s4 = "-" + s;
			//s5 = "_" + s;
			s6 = "." + s;

			if ((isSearch) && (
					((id = v.indexOf(s1)) >= 0) ||
					((id = v.indexOf(s2)) >= 0) ||
					//((id = v.indexOf(s3)) >= 0) ||
					//((id = v.indexOf(s4)) >= 0) ||
					//((id = v.indexOf(s5)) >= 0) ||
					((id = v.indexOf(s6)) >= 0) ||
					(v.startsWith(s)))) {
				nFound++;
			}
			else 
				return (false);
		}
		if (nFound >= nAnds) {
			return (true);
		} else {
			return (false);
		}
	}


	/**
	 *  Description of the Method
	 *
	 * @param  v  Description of the Parameter
	 */
	void parserToken(String v) {
		String s = "";

		int j = 0;

		if (v != null) {
			for (j = 0; j < v.length(); j++) {
				if (v.charAt(j) != ' ') {
					break;
				}
			}

			nAnds = 0;
			for (int i = j; i < v.length(); ) {
				if (v.charAt(i) == '&') {
					// Antes tinha &
					if (s.length() >= 1) {
						vString[nAnds] = s.trim();
						nAnds++;
						for (j = i + 1; j < v.length(); j++) {
							if (v.charAt(j) != ' ') {
								break;
							}
						}
						i = j - 1;
					}
					s = "";
				} else {
					s = s + v.charAt(i);
				}
				i++;
			}
			vString[nAnds] = s.trim();
			nAnds++;
		}
	}


	/**
	 *  Gets the textField attribute of the HTView object
	 *
	 * @return    The textField value
	 */
	String getTextField() {
		String search = textField.getText();

		if ((search == null) || (search.length() == 0)) {
			isSearch = false;
		} else {
			isSearch = true;
		}

		model.setIsSearchText(isSearch);
		// 14/11/2005

		HTModelNode nodeD = model.getRoot();

		searchText(nodeD.getHTnode(), search.toLowerCase());

		if (search.length() == 1) {
			draw.translateToRootOrigin();
		}

		repaint();

		return search;
	}


	/**
	 *  Gets the searchWord attribute of the HTView object
	 *
	 * @return    The searchWord value
	 */
	String getSearchWord() {
		return (textField.getText());
	}


	/**
	 *  Gets the numAnds attribute of the HTView object
	 *
	 * @return    The numAnds value
	 */
	int getNumAnds() {
		return (nAnds);
	}


	/**
	 *  Gets the wordI attribute of the HTView object
	 *
	 * @param  i  Description of the Parameter
	 * @return    The wordI value
	 */
	String getWordI(int i) {
		if (i < nAnds) {
			return (vString[i]);
		} else {
			return (null);
		}
	}


	// 14/11/2005
	/**
	 *  Sets the searchType attribute of the HTView object
	 *
	 * @param  v  The new searchType value
	 */
	void setSearchType(String v) {
		if (v.equals("line")) {
			searchType = false;
		} else {
			searchType = true;
		}
	}


	/**
	 *  Gets the searchType attribute of the HTView object
	 *
	 * @return    The searchType value
	 */
	boolean getSearchType() {
		return (searchType);
	}


	// *****

	// 14/11/2005
	/**
	 *  Gets the isSearch attribute of the HTView object
	 *
	 * @return    The isSearch value
	 */
	boolean getIsSearch() {
		return isSearch;
	}


	// Poligono

	// Nome do arquivo
	/**
	 *  Sets the fileShape attribute of the HTView object
	 *
	 * @param  nome  The new fileShape value
	 */
	public void setFileShape(String nome) {
		nameShape = nome;
	}


	/**
	 *  Gets the fileShape attribute of the HTView object
	 *
	 * @return    The fileShape value
	 */
	public String getFileShape() {
		return nameShape;
	}


	/**
	 *  Gets the indicePoligono attribute of the HTView object
	 *
	 * @return    The indicePoligono value
	 */
	public int getIndicePoligono() {
		return draw.getIndicePoligono();
	}


	/**
	 *  Gets the poligono attribute of the HTView object
	 *
	 * @param  indice    Description of the Parameter
	 * @param  posicaox  Description of the Parameter
	 * @param  posicaoy  Description of the Parameter
	 * @param  largura   Description of the Parameter
	 * @return           The poligono value
	 */
	public Polygon getPoligono(int indice, int posicaox, int posicaoy, int largura) {
		return dlgFormas.getPoligono(indice, posicaox, posicaoy, largura);
	}


	/**
	 *  Description of the Method
	 *
	 * @param  shapes  Description of the Parameter
	 */
	public void criaDlgFormas(HTLoadSVG shapes) {
		//Frame f = new Frame("Formas");
		dlgFormas = shapes;
		//new HTDialogShapes(f, getPath());
	}


	/**
	 *  Gets the rectx attribute of the HTView object
	 *
	 * @param  i         Description of the Parameter
	 * @param  largura   Description of the Parameter
	 * @param  posicaox  Description of the Parameter
	 * @return           The rectx value
	 */
	public int getRectx(int i, int largura, int posicaox) {
		return dlgFormas.getRectx(i, largura, posicaox);
	}


	/**
	 *  Gets the recty attribute of the HTView object
	 *
	 * @param  i         Description of the Parameter
	 * @param  largura   Description of the Parameter
	 * @param  posicaoy  Description of the Parameter
	 * @return           The recty value
	 */
	public int getRecty(int i, int largura, int posicaoy) {
		return dlgFormas.getRecty(i, largura, posicaoy);
	}


	/**
	 *  Gets the width attribute of the HTView object
	 *
	 * @param  i        Description of the Parameter
	 * @param  largura  Description of the Parameter
	 * @return          The width value
	 */
	int getWidth(int i, int largura) {
		return dlgFormas.getWidth(i, largura);
	}


	/**
	 *  Gets the height attribute of the HTView object
	 *
	 * @param  i        Description of the Parameter
	 * @param  largura  Description of the Parameter
	 * @return          The height value
	 */
	int getHeight(int i, int largura) {
		return dlgFormas.getHeight(i, largura);
	}


	/**
	 *  Gets the arqAberto attribute of the HTView object
	 *
	 * @return    The arqAberto value
	 */
	public boolean getArqAberto() {
		return dlgFormas.getArqAberto();
	}


	/**
	 *  Sets the applet attribute of the HTView object
	 *
	 * @param  graphX  The new lineGraph value
	 * @param  lg      The new lineGraph value
	 */
	void setLineGraph(HTVector graphX, boolean lg) {
		graph = graphX;
		lineGraph = lg;
	}


	/**
	 *  Description of the Method
	 *
	 * @return    Description of the Return Value
	 */
	int nGraphLines() {
		if (graph == null) {
			return 0;
		} else {
			return graph.size();
		}
	}


	/**
	 *  Gets the arcName attribute of the HTView object
	 *
	 * @param  i  Description of the Parameter
	 * @return    The arcName value
	 */
	String getArcName(int i) {
		if (graph == null) {
			return null;
		} else {
			HTPointGraph v = (HTPointGraph) graph.elementAt(i);
			return v.getArcName();
		}
	}


	/**
	 *  Gets the graphNode1 attribute of the HTView object
	 *
	 * @param  i  Description of the Parameter
	 * @return    The graphNode1 value
	 */
	Point getGraphNode1(int i) {
		if (graph == null) {
			return null;
		} else {
			HTPointGraph v = (HTPointGraph) graph.elementAt(i);
			if (v != null) {
				Point p = new Point();
				p.x = v.getNode1().getSavedX();
				p.y = v.getNode1().getSavedY();
				return p;
			} else {
				return null;
			}
		}
	}


	/**
	 *  Gets the graphNode2 attribute of the HTView object
	 *
	 * @param  i  Description of the Parameter
	 * @return    The graphNode2 value
	 */
	Point getGraphNode2(int i) {
		if (graph == null) {
			return null;
		} else {
			HTPointGraph v = (HTPointGraph) graph.elementAt(i);
			if (v != null) {
				Point p = new Point();
				p.x = v.getNode2().getSavedX();
				p.y = v.getNode2().getSavedY();
				return p;
			} else {
				return null;
			}
		}
	}


	/**
	 *  Gets the graphColor attribute of the HTView object
	 *
	 * @return    The graphColor value
	 */
	String getGraphColor() {
		return graphColor;
	}

	
	/**
	 *  Sets the graphColor attribute of the HTView object
	 *
	 * @param  color  The new graphColor value
	 */
	void setGraphColor(String color) {
		graphColor = color;
	}
	
	
	boolean mostraGraph(int i) {
		if (graph == null) {
			return false;
		} else {
			HTPointGraph v = (HTPointGraph) graph.elementAt(i);
			if (v != null) {
				return v.getMostra();
			} else {
				return false;
			}
		}
		
	}

	boolean getDirecionado(int i) {
		if (graph == null) {
			return false;
		} else {
			HTPointGraph v = (HTPointGraph) graph.elementAt(i);
			if (v != null) {
				return v.getDirecionado();
			} else {
				return false;
			}
		}

	}

	String getGraphNodeClientData(int i, int j) {
		HTPointGraph v = (HTPointGraph) graph.elementAt(i);
		HTNode x;
		if (j==1)
			x = v.getNode1();
		else
			x = v.getNode2();
		
		return(x.getNodeClientData()); 		
	}

	boolean getGraphHasData(int i, int j) {
		HTPointGraph v = (HTPointGraph) graph.elementAt(i);
		HTNode x;
		if (j==1)
			x = v.getNode1();
		else
			x = v.getNode2();
		
		return(x.getHasData()); 		
	}

	boolean getShowGroup(int i) {
		HTPointGraph v = (HTPointGraph) graph.elementAt(i);
		
		return(v.getShowGroup()); 		
	}

	String  getGroupColor(int i) {
		HTPointGraph v = (HTPointGraph) graph.elementAt(i);
		
		return(v.getGraphColor()); 		
	}



	void setHasArc(int i, int j, boolean val) {
		HTPointGraph v = (HTPointGraph) graph.elementAt(i);
		HTNode x;
		if (j==1)
			x = v.getNode1();
		else
			x = v.getNode2();
		
		x.setHasArc(val); 		
	}


	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 */
	void folderFechadoGraphLine(HTDrawNode node) {
		boolean fechado=false;
		if (node.getNodeClientData().charAt(1) == '0') 
			fechado = true;
		HTFileNode no = (HTFileNode) node.getNode();
		correNo(no, fechado);		
	}


	/**
	 *  Description of the Method
	 *
	 * @param  node  Description of the Parameter
	 * @param  id    Description of the Parameter
	 * @return       Description of the Return Value
	 */
	private void correNo(HTFileNode node, boolean fechado) {
		for (Enumeration e = node.children(); e.hasMoreElements(); ) {
			HTFileNode childNode = (HTFileNode) e.nextElement();
			verificaNo(childNode.getID().trim(), fechado);
			if (!childNode.isLeaf()) {				
				correNo(childNode, fechado);
			}
		}
		return;
	}
	
	private void verificaNo(String id, boolean fechado) {
		for(int i=0; i < nGraphLines(); i++) {
			HTPointGraph v = (HTPointGraph) graph.elementAt(i);
			String id1 =  v.getNode1().getID();
			String id2 =  v.getNode2().getID();
			if (id.equals(id1) || id.equals(id2)) {
				v.setMostra(fechado);
			}
		}
	}
	
	

}

